CREATE OR ALTER procedure EVALUATE_REPORT_ST_OBR (
    ID_REPORT integer)
returns (
    SUMM_CHILDREN numeric(18,2),
    SUMM numeric(18,2),
    FOREIGN_SUMM numeric(18,2),
    FOREIGN_SUMM_CHILDREN numeric(18,2),
    SUMM_NP numeric(18,2),
    SUMM_RBDISP numeric(18,2),
    SUMM_3CHILDREN numeric(18,2))
as
declare variable SEX char(1);
declare variable PSS char(1);
declare variable FFF integer;
declare variable OMS char(1);
declare variable OMS_VZ char(1);
declare variable OMS_M char(1);
declare variable OMS_F char(1);
declare variable BIRTH_DATE date;
declare variable TARGET_DATE date;
declare variable ID_STATTALON integer;
declare variable FYS_PRICE numeric(12,2);
declare variable STAT_SUMM numeric(18,2);
declare variable STAT_CHILD_SUMM numeric(18,2);
declare variable ID_FYSMANUAL integer;
declare variable WAS_CHILD smallint;
declare variable WAS_3CHILD smallint;
declare variable START_DATE date;
declare variable END_DATE date;
declare variable TERR char(4);
declare variable OMS_DET char(1);
declare variable OMS_DET_0 char(1);
declare variable ACT_DATE date;
declare variable DOC_CODE char(10);
declare variable ID_USL integer;
declare variable ID_MIN_PRICE_USL integer;
declare variable MAX_PRICE numeric(12,2);
declare variable NEOT_PRICE numeric(8,2);
declare variable POS_COUNT smallint;
declare variable HEAL_DAYS integer;
declare variable DIAG char(7);
declare variable ID_SOPUT integer;
declare variable SP char(3);
declare variable SP_V char(3);
declare variable URO char(1);
declare variable P_OGRN char(15);
declare variable P_L smallint;
declare variable USL_C char(16);
declare variable PR_ST smallint;
declare variable PR_ST_V smallint;
declare variable S_FSS numeric(18,2);
declare variable I_FSS numeric(18,2);
declare variable ZAP_DATE date;
declare variable PR_TER smallint;
declare variable SUMM_MA_F numeric(18,2);
declare variable SUMM_NE numeric(18,2);
declare variable SUMM_RE numeric(18,2);
declare variable PR_MA smallint;
declare variable YET_SUM numeric(10,2);
declare variable YET_KOL numeric(10,2);
declare variable YET_A numeric(10,2);
declare variable YET_B numeric(10,2);
declare variable YET numeric(10,2);
declare variable YET_COUNT numeric(10,2);
declare variable SUM_ST numeric(10,2);
declare variable SUM_ST_A numeric(10,2);
declare variable SUM_ST_B numeric(10,2);
declare variable KL smallint;
declare variable MIN_PRICE_O numeric(12,2);
declare variable PR_T smallint;
declare variable PR_EKO smallint;
declare variable PR_TU smallint;
declare variable A_GE smallint;
declare variable MK char(5);
declare variable TR_PRICE numeric(12,2);
declare variable ST_OB numeric(12,2);
declare variable PR_R integer;
declare variable PR_USL integer;
declare variable PR_OB integer;
declare variable PR_DIAG integer;
declare variable PR_FAP integer;
declare variable KOD_PODR integer;
declare variable MKL char(6);
declare variable PR_PODY integer;
declare variable PR_KORON integer;
begin
  yet_kol = 0;
  pr_t = 0;
  pr_r = 0;
  pr_usl = 0;
  summ_ma_f = 0;
  summ = 0;
  pr_ma = 0;
  summ_children = 0;
    SUMM_3CHILDREN  = 0;
    SUMM_RBDISP = 0;
    SUMM_NP = 0 ;
    PR_ST = 0;
    I_FSS = 0;
  foreign_summ = 0;
  foreign_summ_children = 0;
  neot_price = 0;
  max_price = 999999999999.99;
  /*find the lpu group*/
   select id_fysmanual, startdate, enddate, lpu_ogrn
    from report where id_report = :id_report
    into :id_fysmanual, :start_date, :end_date, :p_ogrn;
select tarif_neot.tarif from tarif_neot
where (tarif_neot.d_na<= :start_date)  and (( tarif_neot.d_end>= :end_date ) or (tarif_neot.d_end = '30.12.1899') )
    into :neot_price;

  select pr_tr, pr_rent, ab_m, lpu.mkod from lpu where lpu.c_ogrn = :p_ogrn
  into :pr_t, :pr_r, :pr_ma, :mkl;
  /*evaluation cycle*/
  for select stattalon.id_stattalon, stattalon.w, dr, d_za, oms, oms_d, oms_vz, d_0, m, f,
      stattalon.terr, stattalon.d_os, stattalon.ogrn, stattalon.d_zapol, stattalon.kod_podr_rmis
    from stattalon inner join nozolog on (stattalon.id_report = :id_report and stattalon.d_os = nozolog.code)
    where /*stattalon.id_report = :id_report
    and */stattalon.vid_o = '1'
    and ((stattalon.mkod<>'' and stattalon.terr='1137') or (stattalon.terr<>'1137'))
    and ((stattalon.D_ZAPOL >= :start_date  and stattalon.D_ZAPOL <= :end_date) or (stattalon.st_repeat=1))
    and stattalon.rap is null
    into :id_stattalon, :sex, :birth_date, :target_date,
            :oms, :oms_det, :oms_vz, :oms_det_0, :oms_m, :oms_f, :terr, :diag ,
          :p_ogrn, :zap_date, :kod_podr do
  begin /* for each stattalon */
    stat_summ = 0;
    stat_child_summ = 0;
    S_FSS = 0;
    sum_st = 0;
    yet_sum = 0;
    i_fss = 0;
    summ_ne = 0;
    summ_re = 0 ;
    pr_fap = 0;
    pr_koron = 0;
    execute procedure was_child_proc(:birth_date, :target_date) returning_values (:was_child);
    execute procedure was_3child_proc(:birth_date, :target_date) returning_values (:was_3child);
    execute procedure was_age(:birth_date, :target_date) returning_values (:a_ge);
    execute procedure was_fap_proc(:id_report, :kod_podr, :start_date) returning_values (:pr_fap);
    if ((oms = '+')
        and (((was_child = 0) and (oms_vz = '+'))
        or ((was_child = 1) and (was_3child = 0) and (oms_det = '+'))
        or ((was_3child = 1) and (oms_det_0 = '+')))
        and ((sex = '') or (oms_m = '+'))
        and ((sex = '') or (oms_f = '+'))) then
    begin /* for each paid stattalon */
            for select usl_od.k_vr, usl_od.d_okaz
                from fys2006 inner join (usl_od inner join nozolog on (usl_od.id_stattalon = :id_stattalon and usl_od.diag = nozolog.code))
                    on (usl_od.k_usl_mz = fys2006.kod_us_mz and fys2006.idfysmanual = :id_fysmanual)
                where (((fys2006.pos = '+' ) and (fys2006.oms = '+' ))
                or ((fys2006.oms = '+')
                and (((fys2006.kod_sp = '063')or(fys2006.kod_sp = '064')
                or (fys2006.kod_sp = '065') or (fys2006.kod_sp = '066')
                or (fys2006.kod_sp = '067')) or (fys2006.vrvy>0) )))
                and usl_od.k_vr<>''
                and (nozolog.oms = '+')
                and usl_od.o_s<>'3'
                and (((:was_child = 0) and (nozolog.oms_vz = '+'))
                    or ((:was_child = 1) and (:was_3child = 0) and (nozolog.oms_d = '+'))
                    or ((:was_3child = 1) and (nozolog.d_0 = '+')))
                and ((:sex = '') or (nozolog.m = '+'))
                and ((:sex = '') or (nozolog.f = '+'))
                group by usl_od.k_vr, usl_od.d_okaz
                order by usl_od.k_vr, usl_od.d_okaz
                into :doc_code, :act_date do
            begin /* for each date and doctor in stattalon */
                fys_price = 0;
                yet_b = 0;
                yet_a = 0;
                sum_st_a = 0;
                sum_st_b = 0;
                summ_ne = 0;
                summ_re = 0;
                yet = 0;
                kl = 0;
                pr_usl = 0;
                pr_st = 0;
                pr_st_v = 0;
                fff = 0;
                tr_price = 0;
                min_price_o = max_price;
     execute procedure WAS_SPEZ_V_PROC (:doc_code, :id_report) returning_values (:sp_v);
     pr_st_v = 0;
     if ((sp_v = '063') or (sp_v = '064') or (sp_v = '065') or (sp_v = '066') or (sp_v = '067') ) then
        pr_st_v = 1;
     execute procedure was_spez_pr_proc (:doc_code, :id_report) returning_values (:pr_ter);
                 id_min_price_usl = null;
                
                for select usl_od.id_usl_od, fys2006.kod_sp, usl_od.urov, usl_od.k_usl_mz, usl_od.kol,
                usl_od.pttru, fys2006.mkr, fys2006.pos , usl_od.pr_stom
                   from fys2006 inner join (usl_od inner join nozolog on usl_od.diag = nozolog.code)
                      on usl_od.k_usl_mz = fys2006.kod_us_mz
                    where usl_od.id_stattalon = :id_stattalon
                    and usl_od.d_okaz = :act_date
                    and usl_od.k_vr = :doc_code
                    and usl_od.o_s<>'3'
                    and fys2006.idfysmanual = :id_fysmanual
                    and (((fys2006.pos = '+' ) and (fys2006.oms = '+' ))
                or ((fys2006.oms = '+')
                and (((fys2006.kod_sp = '063')or(fys2006.kod_sp = '064')
                or (fys2006.kod_sp = '065') or (fys2006.kod_sp = '066')
                or (fys2006.kod_sp = '067')) or (fys2006.vrvy>0) )))
                    and (nozolog.oms = '+')
                    and (((:was_child = 0) and (nozolog.oms_vz = '+'))
                       or ((:was_child = 1) and (:was_3child = 0) and (nozolog.oms_d = '+'))
                       or ((:was_3child = 1) and (nozolog.d_0 = '+')))
                    and ((:sex = '') or (nozolog.m = '+'))
                    and ((:sex = '') or (nozolog.f = '+'))
                    order by usl_od.k_usl_mz
                    into :id_usl, :sp, :uro, :usl_c, :kl, :pr_tu, :mk, :pss, :pr_usl do
                begin
                pr_st = 0;
if ((sp <> '039')and ((sp = '063') or (sp = '064') or (sp = '065') or (sp = '066') or (sp = '067') )or (pr_usl=1))then
begin
         pr_st = 1;
execute procedure  calc_usl_proc ( :usl_c, :id_fysmanual, :was_child) returning_values (:yet);
end
     execute procedure  WAS_EKO_PROC ( :usl_c, :sex , :diag , :pr_ma, :p_ogrn) returning_values (:pr_eko);
/*    */
if ((ib_substr(usl_c,1,1)='B') and (pss='+')) then
    begin
   if (pr_eko=1) then
   begin
      execute procedure  WAS_LIC_PROC ( :SP, :uro , :p_ogrn , :was_child, :zap_date) returning_values (:p_l);
      if ((sp='047') and (a_ge<15))then
      Begin
      p_l = 0;
      end
       if (p_l=1) then
                  begin
      execute procedure  calc_usl_newp_roc ( :uro, :p_ogrn , :was_child, :usl_c, :id_fysmanual, :pr_usl) returning_values (:min_price_o);
          if (fys_price = 0) then
          begin
         if ((sp_v = sp) or ((pr_st=1) and (pr_st=pr_st_v) ) )  then
              begin
              fys_price = min_price_o ;
              id_min_price_usl = id_usl;
   if ((pr_t=1) and (pr_tu=1) and (mk='1 ') ) then
         begin
 fff = trunc(:neot_price*1*100.00);
 tr_price =  fff /100.00;
 fff = 0;
 tr_price = :neot_price;
         end
         if (pr_st =1) then     /*ctom*/
         begin
         yet_b = yet;
   if ((pr_t=1) and (pr_tu=1) and (mk='1 ')) then
         begin
         sum_st_b = tr_price;
         end
         else
         sum_st_b = fys_price;
         end
              end
          end
          else
          begin
           if ((sp_v = sp) or ((pr_st=1) and (pr_st=pr_st_v) ) ) then
              begin
               fys_price = min_price_o ;
               id_min_price_usl = id_usl;
   if ((pr_t=1) and (pr_tu=1) and (mk='1 '))  then
         begin
 fff = trunc(:neot_price*1*100.00);
 tr_price =  fff /100.00;
 fff = 0;
 tr_price = :neot_price;
         end
         if (pr_st =1) then      /*ctom*/
         begin
         yet_b = yet;
   if ((pr_t=1) and (pr_tu=1) and (mk='1 ')) then
         begin
         sum_st_b = tr_price;
         end
         else
         sum_st_b = fys_price;
         end
         end
          end
                  end
   end     /*eko*/
    end         /* */
    else
    begin      /* */
   if (pr_eko=1) then
   begin
      execute procedure  WAS_LIC_PROC ( :SP_V, :uro , :p_ogrn , :was_child, :zap_date) returning_values (:p_l);
      if ((sp_v='047') and (a_ge<15))then
      Begin
      p_l = 0;
      end
       if (p_l=1) then
                  begin
      pr_diag = 0;
      pr_koron = 0;
      if (usl_c = 'A26.08.008.001') then
      pr_koron = 1;
      execute procedure  calc_usl_diag ( :usl_c, :zap_date) returning_values (:pr_diag);     /*diagnosti yslygi*/
      execute procedure  calc_usl_newp_roc ( :uro, :p_ogrn , :was_child, :usl_c, :id_fysmanual, :pr_usl) returning_values (:min_price_o);
      if ( ((sp_v = sp) and (pr_st = 1)) or ((pr_st=1) and (pr_st=pr_st_v) )  ) then          /**/
      begin
      yet_a = kl * yet;
      fys_price = min_price_o * kl;
      sum_st_a = sum_st_a + min_price_o * kl;
           update usl_od set paid = 2, usl_od.usl_code = :fys_price,
           usl_od.t_fed = 0, usl_od.t_ych =0, usl_od.ok_finu = 0, usl_od.yet = :yet_a, usl_od.mkru = :mk
                    where id_usl_od = :id_usl;
      end
      else
      begin
        if (((sp='039') and (pr_r=1) and (sp_v = sp)) or ((sp<>'039') and(:pr_diag = 1)))  then
          begin
       if (min_price_o>0) then
       begin
      if (sp<>'039') then
      begin
    update usl_od set paid = 1, usl_od.usl_code = :min_price_o, usl_od.t_fed = 0, usl_od.t_ych =0,
    usl_od.ok_finu = 0, usl_od.st_tr = :fys_price, usl_od.mkru = :mk, usl_od.sp = :sp_v
                    where id_usl_od = :id_usl;
    summ_re = summ_re + :min_price_o;
    end
    else
    begin
    update usl_od set paid = 1, usl_od.usl_code = :min_price_o*:kl, usl_od.t_fed = 0, usl_od.t_ych =0,
    usl_od.ok_finu = 0, usl_od.st_tr = :fys_price, usl_od.mkru = :mk, usl_od.sp = :sp_v
                    where id_usl_od = :id_usl;
    summ_re = summ_re + :min_price_o*:kl;
    end
     fys_price = 0;
     min_price_o = 0;
       end
       else
    update usl_od set paid = 0, usl_od.usl_code = :min_price_o*:kl, usl_od.t_fed = 0, usl_od.t_ych =0,
    usl_od.ok_finu = 0, usl_od.st_tr = :fys_price, usl_od.mkru = :mk, usl_od.sp = :sp_v
                    where id_usl_od = :id_usl;
     fys_price = 0;
          end
          if ((sp<>'039') and (fys_price = 0)) then
          begin
           fys_price = min_price_o ;
           id_min_price_usl = id_usl;
          end
          if ((sp<>'039') and (fys_price <> 0) and (min_price_o = 0)) then
          begin
           pr_st = 0 ;
          end

      end
                  end
     end        /*eko*/
    end   /*    */
                    end
          if (pr_st = 1) then
          begin
           yet_sum = yet_sum + yet_a + yet_b;
           sum_st = sum_st + sum_st_a + sum_st_b;
          end
          /*neotl*/
          if (summ_ne>0) then
          begin
          stat_summ = stat_summ + summ_ne;
           if (was_child=1) then
           stat_child_summ = stat_child_summ + summ_ne;
          end
          /*rent*/
          if (summ_re>0) then
          begin
          stat_summ = stat_summ + summ_re;
           if (was_child=1) then
           stat_child_summ = stat_child_summ + summ_re;
          end

                if ((fys_price <> 0) or (sum_st>0) and (summ_ne = 0) and (summ_re = 0) ) then
                begin
   if (pr_st=0) then
           begin
           if (tr_price=0) then
           begin
                stat_summ = stat_summ + fys_price  ;
           end
           else
           stat_summ = stat_summ + tr_price;
           end
                if (was_child=1) then
                begin
                if (tr_price=0) then
           begin
                stat_child_summ = stat_child_summ + fys_price  ;
           end
                else
                stat_child_summ = stat_child_summ + tr_price;
                end
         if ((pr_st = 0) and (tr_price=0)) then
         begin
                         update usl_od set paid = 1, usl_od.usl_code = :fys_price,
                    usl_od.t_fed = 0, usl_od.t_ych =0, usl_od.ok_finu = 0,
                    usl_od.st_tr = :tr_price, usl_od.mkru = :mk, usl_od.sp = :sp_v
                    where id_usl_od = :id_min_price_usl;
         end
         if ((pr_st = 0) and (tr_price>0)) then
                    update usl_od set paid = 1, usl_od.usl_code = :tr_price,
                    usl_od.t_fed = 0, usl_od.t_ych = 0, usl_od.ok_finu = 0,
                    usl_od.st_tr = :fys_price, usl_od.mkru = :mk, usl_od.sp = :sp_v
                    where id_usl_od = :id_min_price_usl;
           if ((pr_st = 1) and (yet_b>0)and (tr_price=0)) then
           begin
           update usl_od set paid = 1, usl_od.usl_code = :sum_st_b,
           usl_od.t_fed = 0, usl_od.t_ych = 0, usl_od.ok_finu = 0,
           usl_od.yet = :yet_b, usl_od.mkru = :mk, usl_od.sp = :sp_v
                    where id_usl_od = :id_min_price_usl;
  end
           if ((pr_st = 1) and (yet_b>0)and (tr_price>0)) then
           begin
           update usl_od set paid = 1, usl_od.usl_code = :tr_price,
           usl_od.t_fed = 0, usl_od.t_ych = 0, usl_od.ok_finu = 0,
           usl_od.yet = :yet_b , usl_od.st_tr = :fys_price, usl_od.mkru = :mk
           , usl_od.sp = :sp_v
                    where id_usl_od = :id_min_price_usl;
  end

                end
            end /* for each date and doctor in stattalon */
 /*  */
stat_summ = stat_summ +sum_st;
        if (terr = '1137') then /*  */
        begin /* if local */
            /*summ = summ + stat_summ;*/
            yet_kol = yet_kol + yet_sum;
            summ_children = summ_children + stat_child_summ;
        end /* if local */
        else
        begin /* if foreign */
            /*foreign_summ = foreign_summ + stat_summ;*/
            foreign_summ_children = foreign_summ_children + stat_child_summ;
        end /* if foreign */

    end /* for each paid stattalon */
    /* evaluate pos count & heal days for main stattalon diag */
/*kontrastirovanie  */
 execute procedure  CALC_KONTR_USL (:id_stattalon);
/* obracheni*/
    st_ob = 0;
  if (not(diag like 'Z%')) then
  begin
 execute procedure  calc_obr_usl (:id_stattalon, :zap_date, :was_child,:p_ogrn) returning_values (:st_ob);
  end
        if (st_ob is null) then
        st_ob = 0;
    if (st_ob=0) then
     pr_ob = 0;
     else
     pr_ob = 1;
/*koronovirus A26.08.008.001*/
if (pr_koron = 1) then
 execute procedure  calc_kor_usl (:id_stattalon, :p_ogrn, :id_fysmanual) ;

    pos_count = 0;
    select sum(usl_od.kol) from usl_od where usl_od.id_stattalon = :id_stattalon and paid = 1
    and usl_od.yet=0 and usl_od.usl_code>0
        into :pos_count;
        if (pos_count is null) then
        pos_count = 0;
    yet_count = 0;
    select sum(usl_od.yet)  from usl_od where usl_od.id_stattalon = :id_stattalon
    and ((paid = 1) or (paid = 2)) and usl_od.yet>0
        into :yet_count;
        if (yet_count is null) then
        yet_count = 0;
        stat_summ = 0;
    select sum(usl_od.usl_code) from usl_od where usl_od.id_stattalon = :id_stattalon and
    (usl_od.obr is null) and usl_od.yet=0 and usl_od.paid=1
        into :stat_summ;
        if (stat_summ is null) then
        stat_summ = 0;
        stat_summ = stat_summ + st_ob +sum_st;
        s_fss = s_fss + pos_count;
        summ_rbdisp = summ_rbdisp + i_fss;
    execute procedure calc_heal_days(:id_stattalon, :diag) returning_values(:heal_days);
    execute procedure WAS_PODYS_PROC(:id_report, :id_fysmanual, :id_stattalon, :pr_t, :mkl) returning_values(:pr_pody);
        update stattalon
        set stattalon.summ = :stat_summ, stattalon.was_child = :was_child, stattalon.pos_count = :pos_count,
        stattalon.heal_days = :heal_days, stattalon.Rap = '1', stattalon.sum_fss = 0, stattalon.mod_ych = 0,
        stattalon.ok_fin = 0, stattalon.yet = :yet_count, stattalon.age = :a_ge, stattalon.pr_obr = :pr_ob,
        stattalon.pr_fap = :pr_fap, stattalon.pr_opl_pod = :pr_pody
    where id_stattalon = :id_stattalon;
    s_fss = 0;
        if (terr = '1137') then /*  */
        begin /* if local */
            summ = summ + stat_summ;
        end /* if local */
        else
        begin /* if foreign */
            foreign_summ = foreign_summ + stat_summ;
        end /* if foreign */
  /* evaluate pos count & heal days for soput stattalon diags */
    for select soput.id_soput, soput.diag from soput where soput.id_stattalon = :id_stattalon
        into :id_soput, :diag do
    begin
        pos_count = 0;
        select count(*) from usl_od where usl_od.id_stattalon = :id_stattalon and paid = 1 and usl_od.diag = :diag
        and usl_od.yet=0 and usl_od.usl_code>0    into :pos_count;
        execute procedure calc_heal_days(:id_stattalon, :diag) returning_values(:heal_days);
        update soput set pos_count = :pos_count, heal_days = :heal_days where id_soput = :id_soput;
    end
    /* evaluate pos count & heal days for soput stattalon diags */
  end /* for each stattalon */
  update report set
    evaluatedsumm = :summ, evaluatedchildsumm = :summ_children,
    evalforeignsumm = :foreign_summ, evalforeignchildsumm = :foreign_summ_children ,
    report.sfactnersumm = :SUMM_RBDISP, report.evaluatednpsumm = :summ_np,
    report.sfforeignnpsumm = :summ_ma_f,
    report.ok_fin_in = 0, report.yet_r = :yet_kol
    where id_report = :id_report;

end